



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL数据库中日期中包涵零值的问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL数据库中日期中包涵零值的问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 19:07:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>默认情况下MySQL是可以接受在日期中插入0值，对于现实来说日期中的0值又没有什么意义。调整MySQL的sql_mode变量就能达到目的。</p>
<div>
<pre class="prettyprint linenums">set @@global.sql_mode='STRICT_TRANS_TABLES,NO_ZERO_DATE,NO_ENGINE_SUBSTITUTION';<br />
set @@session.sql_mode='STRICT_TRANS_TABLES,NO_ZERO_DATE,NO_ENGINE_SUBSTITUTION';</pre>
</div>
<p>例子：</p>
<p>　　有一个用于记录日志的表</p>
<div>
<pre class="prettyprint linenums">create table app_logs(<br />
    id int not null auto_increment primary key,<br />
    log_tm timestamp not null,<br />
    log_info varchar(64) not null)<br />
    engine=innodb,charset=utf8;</pre>
</div>
<p>　　向日志表插入有意思的日期值</p>
<div>
<pre class="prettyprint linenums">insert into app_logs(log_tm,log_info) values(now(),'log_info_1');<br />
insert into app_logs(log_tm,log_info) values('2016-12-01','log_info_2');</pre>
</div>
<p>　　向日志表插入包涵0的日期值</p>
<div>
<pre class="prettyprint linenums">insert into app_logs(log_tm,log_info) values('2016-12-00','log_info_2');<br />
ERROR 1292 (22007): Incorrect datetime value: '2016-12-00' for column 'log_tm' at row 1</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqll3y1q.html">JS实现带复选框的下拉菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx6o6q.html">进程控制块&lpar;Process Control Block&comma; PCB&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4zdr9.html">python3，交互模式，无法使用ctrl和方向键，需要和ctrl一块用</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rovx79.html">LightOJ1064 Throwing Dice（DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mlng8.html">plsql日期乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e12ore9.html">Linux Kernel &OpenCurlyQuote;oz&lowbar;cdev&lowbar;write&lpar;&rpar;&rsquo;函数本地缓冲区溢出漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xedm08.html">selenium webdriver python 元素操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojy55pq.html">Kintinuous 相关论文 Volume Fusion 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k11r69.html">【转】线段树完全版~by NotOnlySuccess</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodwz1q.html">使用C&plus;&plus;对物理网卡&sol;虚拟网卡进行识别（包含内外网筛选）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5dz1rq.html">python中的lambda表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ompnj8.html">MJRefresh在Xode6中报错处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdkyke9.html">初始IP协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyy5lgq.html">Redis的使用及参考代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22k2rq.html">SpringBoot条件注解&commat;Conditional</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwdyox9.html">AMD&sol;CMD&sol;CommonJs到底是什么？它们有什么区别？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ondoe8.html">Java的家庭记账本程序（C）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960zxd49.html">USB协议介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wr50zq.html">AndroidStudio2&period;2 Preview3中NDK开发之CMake和传统 JNI在目录结构和配置文件上的区别（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ndgk9.html">http协议与url简介（转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4y0zm0q.html">hdu 3681 Prison Break</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydk1rdq.html">uva 10034 Problem A&colon; Freckles</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvl2o1q.html">安卓u8800刷机</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w45nxq.html">pydev package包中&lowbar;&lowbar;init&lowbar;&lowbar;&period;py作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1wk6v9.html">【转】android使用File Explorer无法访问系统内部文件--不错</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vg24j8.html">WIN7笔记本显示连接不可用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn0l60q.html">ubantu14&period;04 apache2 支持重写模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vge548.html">js继承的三种实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2ww38.html">大学生程序猿IT情书&OpenCurlyDoubleQuote;2014爱的告白挑战赛&rdquo;获奖名单及优秀情书展示系列之 - 【IT术语】情书&plus;【搞笑另类】情书</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k172xj9.html">三、Solr多核心及分词器（IK）配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
